/// <reference types="node" />
import SteamID from 'steamid';
import { ApproveAuthSessionRequest, AuthSessionInfo, ConstructorOptions } from './interfaces-external';
export default class LoginApprover {
    private _accessToken;
    sharedSecret: string | Buffer;
    private _webClient;
    private _handler;
    constructor(accessToken: string, sharedSecret: string | Buffer, options?: ConstructorOptions);
    get steamID(): SteamID;
    get accessToken(): string;
    set accessToken(token: string);
    private get _secretAsBuffer();
    getAuthSessionInfo(qrChallengeUrl: string): Promise<AuthSessionInfo>;
    approveAuthSession(details: ApproveAuthSessionRequest): Promise<void>;
}
//# sourceMappingURL=LoginApprover.d.ts.map