/// <reference types="node" />
import { Agent as HttpAgent } from 'http';
/**
 * Get an Agent that connects through a proxy.
 * @param {boolean} secure - Will the connection to the destination server be secure? NOT the connection to the proxy.
 * @param {string|null} proxyUrl - The URL of the proxy, including the protocol, auth (if applicable), host, and port
 * @param {int} [proxyTimeout=5000] - Timeout for connecting to the proxy, in milliseconds
 * @returns {HttpAgent|HttpsAgent|boolean}
 */
export default function getProxyAgent(secure: boolean, proxyUrl: string, proxyTimeout?: number): false | HttpAgent;
//# sourceMappingURL=proxyagent.d.ts.map