import State from './enums/State';
import FrameType from './enums/FrameType';
import StatusCode from './enums/StatusCode';
import WebSocket from './WebSocket';
import WebSocketServer from './WebSocketServer';
import WebSocketServerConnection from './WebSocketServerConnection';
import StreamedIncomingMessage from './streams/StreamedIncomingMessage';
import StreamedOutgoingMessage from './streams/StreamedOutgoingMessage';
import { HandshakeData } from './interfaces-external';
export { State, FrameType, StatusCode, WebSocket, WebSocketServer, WebSocketServerConnection, StreamedIncomingMessage, StreamedOutgoingMessage, HandshakeData };
declare const _default: {
    State: typeof State;
    FrameType: {
        Continuation: number;
        Data: {
            Text: number;
            Binary: number;
        };
        Control: {
            Close: number;
            Ping: number;
            Pong: number;
        };
    };
    StatusCode: typeof StatusCode;
    WebSocket: typeof WebSocket;
    WebSocketServer: typeof WebSocketServer;
};
export default _default;
//# sourceMappingURL=index.d.ts.map